# finger.pl -- WWW to finger gateway (with faces support)
#
# $Id: finger.pl,v 2.1 1993/05/23 23:47:56 sanders Exp $
#
# Marc VanHeyningen  March 1993
#
# This is a simple gateway into finger space from HTTP.
# It is intended to be fast and not to laden the HTTP server, which is
# why it uses sockets within perl rather than simply execing finger.
#
# Examples:
$map{'finger'} = '&do_finger($rest, $query)';

do 'sys/socket.ph';
eval 'sub AF_INET {2;}'         unless defined &AF_INET;
eval 'sub SOCK_STREAM {1;}'     unless defined &SOCK_STREAM;

# $hostname comes from config file
($name, $aliases, $finger_port) = getservbyname("finger","tcp");
($name, $aliases, $proto) = getprotobyname("tcp");
($name, $aliases, $type, $len, $thisaddr) = gethostbyname($hostname);

sub do_finger {
    local($path, $query) = @_;
    local($user, $site, $sockaddr, $fqdn, $aliases, $type, $len, $thataddr);
    local($face, $bogus);

    if($query =~ /^([\w\-\.]+)@([\w\-\.]+)$/) {
	$user = $1;
	$site = $2;
    } elsif($path eq "gateway") {
	&retrieve($finger_cover);
	return;
    } elsif($path =~ m:^([\w\-\.]+)/([\w\-\.]+)$:) {
	$site = $1;
	$user = $2;
    } else {
	&error('bad_request', "Invalid finger path $path");
    }
    $sockaddr = "S n a4 x8";

    ($fqdn, $aliases, $type, $len, $thataddr) = gethostbyname($site);
    if($fqdn eq "") {
	$fqdn = $site;
	$bogus = 1;
    }

    &MIME_header('ok', 'text/html');
    print "<HEADER>\n<TITLE>Finger Gateway</TITLE>\n</HEADER>\n";
    print "</BODY>\n<H1>\n";
    if(($face = &get_face_path($user, $fqdn)) ne "") {
	print NS '<IMG SRC="/', $face, '">', "\n";
    }
    print "$user@$fqdn";
    foreach $face (&get_face_path("unknown", $fqdn)) {
	print '<IMG SRC="/', $face, '">', "\n";
    }
    print "</H1>\n<XMP>\n";
    if($bogus) {
	print "gethostbyname: cannot look up $fqdn\n";
	return;
    }

    # get finger text
    alarm($http_timeout);
    $this = pack($sockaddr, &AF_INET, 0, $thisaddr);
    $that = pack($sockaddr, &AF_INET, $finger_port, $thataddr);
    socket(FS, &AF_INET, &SOCK_STREAM, $proto) ||
        &error('internal_error', "socket: $!");
    bind(FS, $this) || &error('internal_error', "bind: $!");
    connect(FS, $that) || &error('internal_error', "connect: $!");
    select(FS); $| = 1;
    print "$user\r\n";
    select(NS);
    while(<FS>) { print; }
    close(FS);
    print "</XMP>\n";
    print "</BODY>\n";
}


sub get_face_path {
    local($user, $fqdn) = @_;
    local(@hits, $filename);
    $user =~ tr/[A-Z]/[a-z]/;
    $fqdn =~ tr/[A-Z]/[a-z]/;

  CHECK_DIR:
    foreach $face_dir (@faces_path) {
	local(@fqdn) = reverse(split(/\./, $fqdn));

	while($#fqdn >= $[) {
	    $filename = $face_dir . "/" . join("/",@fqdn) . "/" .
		$user . "/face.xbm";
	    if(-e $filename) {
		last CHECK_DIR unless wantarray;
		push(@hits, $filename);
	    }
	    pop @fqdn;
	}
	last CHECK_DIR if(@hits);
	$filename = "";
    }
    return wantarray ? @hits : $filename;
}

1;
