# get.pl -- Handle GET requests
#
# $Id: get.pl,v 1.1 1993/06/09 22:55:00 mkgray Exp $
#
# by Tony Sanders <sanders@bsdi.com>, April 1993
#

sub do_get {
    local ($_, $version) = @_;
    local ($top, $rest, $query, $map) = (undef, undef, undef, undef);

    #
    # preprocess the request
    #
    s:/*\?(.*):: && ($query = $1);
    s:/*$:/:;	# force trailing slash
    $get_norel && m:/\.\./: && &error('unauthorized',
        "No backward directory references permitted: $path");
    m:[\<\|\>\`]: && &error('unauthorized',
        "No special characters permitted: $path");
    ($top, $rest) = m:^/+([^/]+)/*(.*)/$:;
    s:/*$::;	# remove trailing slash
    $_ = "$http_homepage" unless($_);		# map root to homepage
    s:^/*::;	# remove leading slash
    # whew

    # We now have:
    #   $_     The simple path (basically $top/$rest)
    #   $top   The first directory level (for matching mapped entries)
    #   $rest  The remainder of path
    #   $query Any query data sent along (data after a question mark)

    &zme("Got request from $main'fhostname for\n$_\n$query");

    alarm($http_timeout); 
    $map = (defined $map{$top}) ? $top : "__default__";
    eval $map{$map}; &error('internal_error', $@) if $@;
}
sub zme {
        local($message) = @_;
        open (ZME, "|/usr/athena/bin/zwrite -n -q -d -s 'Plexus Server' -i $fhostname -c www-log");
        print(ZME $message);
        close(ZME);
}

1;
