# walk.pl -- image selection decoder for walk.gif
#
# $Id: walk.pl,v 2.1 1993/05/23 23:48:14 sanders Exp $
#
# Tony Sanders <sanders@bsdi.com>, April 1993
#
# Examples:
$map{'decode_walk'} = '&do_decode_walk($_, $query)';
require "$http_sdir/decode.pl";

sub do_decode_walk {
    local($_, $query) = @_;
    local($i, %image);

    $image{'root'} = "$http_sdir/walk";
    $image{'width'} = 106;
    $image{'height'} = 110;
    $image{'regions'} = "camera:pack:astronaut:earth";

    # Make a menu for people without the new browser hack
    unless (defined $query) {
	&MIME_header('ok', 'text/html');
	print "<HEADER>\n<TITLE>Space Walk</TITLE>\n</HEADER>\n";
	print "<BODY>\nYou can select one of:\n";
	print "<UL>\n";
	print "<LI> <A HREF=\"/decode_walk?60,50\">Astronaut</A>\n";
	print "<LI> <A HREF=\"/decode_walk?63,6\">Camera</A>\n";
	print "<LI> <A HREF=\"/decode_walk?89,44\">Space Suit</A>\n";
	print "<LI> <A HREF=\"/decode_walk?105,109\">Earth</A>\n";
	print "<LI> <A HREF=\"/decode_walk?0,0\">Space</A>\n";
	print "</UL>\n</BODY>\n";
	return;
    }

    local($x, $y) = split(",", $query);

    foreach $i (split(":", $image{'regions'})) {
	&region("$image{root}/$i.mask",
	    $image{'width'}, $image{'height'},
	    $x, $y) && &retrieve("$image{root}/$i.html") && return;
    }

    # DEFAULT
    &MIME_header('ok', 'text/html');
    print "<HEADER>\n<TITLE>Outer Space</TITLE>\n</HEADER>\n";
    print "<BODY>\nYou selected outer space\n</BODY>\n";
}

1;
