# get.pl -- Handle GET requests
#
# $Id: get.pl,v 1.3 1993/12/15 09:27:09 root Exp $
#
# by Tony Sanders <sanders@bsdi.com>, April 1993
#

# XXX: should probably handle TEXTSEARCH requests here also

sub do_get {
    local ($_, $version) = @_;
    local ($top, $rest, $query, $map) = (undef, undef, undef, undef);

    #
    # preprocess the request
    #
    s:\?(.*):: && ($query = $1);		# extract query (if any)
    s:.*:/$&/:;	s:/+:/:g;			# force leading and trailing /
    $get_norel && m:/\.+/: && &error('unauthorized',
	    "No backward directory references permitted: $_");
    m:[\<\|\>\`]: && &error('unauthorized',
        "No special characters permitted: $_");
    $_ = "/$http_homepage/" if $_ eq "/";	# special case home page
    s:^/::; s:/$::;				# cleanup
    ($top, $rest) = split("/", $_, 2);

    # We now have:
    #   $_     The simple path (basically $top/$rest)
    #   $top   The first directory level (for matching mapped entries)
    #   $rest  The remainder of path
    #   $query Any query data sent along (data after a question mark)

&zme("Got request from $main'fhostname for\n$_\n$query");

    alarm($http_timeout); 
    $map = (defined $map{$top}) ? $top : "__default__";
    eval $map{$map}; &error('internal_error', $@) if $@;
}

#sub zme {
#        local($message) = @_;
#        open (ZME, "|/usr/athena/bin/zwrite -n -q -d -s 'Plexus Server' -i $fhostname -c www-log");
#        print(ZME $message);
#        close(ZME);
#}

require "$http_sdir/zsend.pl";

sub zme {
	local($message) = @_;
	local($default_format) = 'Class $class, Instance $instance:
To: @bold($recipient) at $time $date
From: @bold(Plexus Server) <$sender>

$1';
	&zsend(&zpacket('', 'www-log', $fhostname, '', 'www',
			'', $default_format, $message));
}

1;
