# siks.pl -- Simple Index Keyword Search
#
# $Id: mysiks.pl,v 1.1 93/08/11 00:17:20 root Exp $
#

sub mysiks {
    local($index_fn, $index_data, $title, $display_line, $prefix, $suffix, $keywords) = @_;
   
    local(@hits,$hits,$i,$searcher);

    local(@keywords) = split(/\+/, $keywords);

    open(INDEX, $index_fn) || &error('bad_request',
				     "cannot open $index_fn: $!");
    open(DINDEX, $index_data) || &error('bad_request',
					"cannot open $index_data: $!");
    flock(INDEX, &LOCK_SH);	# 
    $searcher = 'while(<INDEX>) { $hits = 0; ' . "\n";
    $searcher .= 'study; ' if($#keywords > 5);
    foreach $keyword (@keywords) { 
	$searcher.= '$hits++ if(/' . $keyword . '/i); ' . "\n"
	    if($keyword =~ /[\w\-]+/);
    }
    $searcher .= 'push(@hits,substr($_, 0, index($_, ";"))) if $hits;';
    $searcher .= 'push(@nhits, $hits) if $hits;';
    $searcher .= '; }' . "\n";
    eval $searcher;
    $found = 1 if @nhits;
    close(INDEX);

    print '<ISINDEX><TITLE>Simple Index Keyword Search of ', $title, '</TITLE>', "\n";
    print '<H1>', $title, '</H1>', "\n";
    print '<H2>Keywords: ', join(" ",@keywords), '</H2>', "\n";

    alarm($http_timeout);
    $centry = shift(@hits);
    $nentry = shift(@nhits);
#    &zme("$nentry hits for record $centry\n");
    $/="\n";
    while(<DINDEX>){
	do{($centry = &$display_line($_, $nentry, *hits));$nentry = shift(@nhits);} if /^$centry/;
    }
    $/="\n"; 
    

    foreach $entry (split("\n", $hits[$i])) {
	do $display_line($entry);
	alarm($http_timeout);
    }
    print $suffix;
    alarm($http_timeout);


    print '<H3>', "Nothing found.", '</H3>' if(!$found && $keywords ne "");
    print "\n";
    alarm($http_timeout);
}

1;
